#version 330
#define ALPHA_KEYno

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform sampler2DRect maskTex;
in vec2 fsMaskTexture;


in vec2 fsTexture;
in vec2 fsTexture2;

out vec4 outColor;

void main()
{
	 vec4 colorA = texture(inputTex, fsTexture);
	 vec4 colorB = texture(inputTex1, fsTexture2);
#ifdef ALPHA_KEY
	float blend=colorA.a*colorB.a;
	vec4 mixed=mix(colorB.rgba,colorA.rgba,transitionProgressLinear);
	colorB.a*=(1.0-transitionProgressLinear);
	colorA.a*=(transitionProgressLinear);
	outColor=mix(colorB+colorA,mixed,blend);
#else
	outColor=mix(colorB,colorA,transitionProgressLinear);
#endif
	
#ifdef USE_MASK
	 outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}


